#include<iostream>
#include<queue>
#include<vector>
#include<set>
#include<map>

using namespace std;

set<int> ans;
int n, h;
map<int, set<int>> g;

void bfs(int start) {
    vector<int> dist(n, 1000000000);
    dist[start] = 0;
    queue<int> q;
    q.push(start);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int u: g[v]) {
            if (dist[u] == 1000000000) {
                dist[u] = dist[v] + 1;
                q.push(u);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (dist[i] <= h) {
            ans.insert(i + 1);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].insert(b);
        g[b].insert(a);
    }
    for (int i = 0; i < k; i++) {
        int p;
        cin >> p >> h;
        p--;
        bfs(p);
    }
    cout << ans.size() << '\n';
    for (int el: ans) {
        cout << el << ' ';
    }
    return 0;
}
